	include "pck1.inc"
; okaegi v 7
; dip switches 32, 31 ball set (1,1 -> 2, 1,0 -> 4, 0,1-> 5, 0,0 -> 3)
; dip switches used dip 28, match on
; dip switches used dip 27 , display credits
; dip switches used dip 26 , max credits
; dip switches used dip 25 , max credits (freegame)
;
; Memory chip map
;
; adr 1800 - 1fff U6	-> pck
; adr 5800-  58ff U6	-> pck 
; adr 1000 - 17ff U2	-> game rom
; adr 5000 - 57ff U2	-> game rom
;
;	
; 200 - 20f 				* Lamp board *
; 20f - 21e 				* aux lamp board *
; 21e - 240				* displays *
; 241 242 243 244 245 246 247 <- reserved for additional display (used only on vector / medusa)
;
; 264 - 28E			**** free (game or player specfic) ****
;
; 280 - 2ff 			save over power off
;
; game parameters			**** free ***
;     	2af 2b0				test 06
;	2b1 2b2				test 07
;	2b3 2b4				test 08
;	2b5 2b6				test 09
; 	2b7 2b8				test 10
;	2b9 2ba				test 11
;	2bb 2bc				test 12
;	2bd 2be				test 13
;	2bf				** free ***
;	2c0-2cf				** free player 1 save area ***
;	2d0-2df				** free player 2 save area ***
;	2e0-2df				** free player 3 save area ***
;	2f0-2ff				** free player 4 save area ***
;
; predefines lamps		
;
; $020A 8765FFFF
;  8 -> credit indicator	j3 13		
;  7 -> S.P. SHOOT AGAIN	j3 22		
;  6 -> MATCH			j2 8  / j1 4	
;  5 -> SHOOT AGAIN		j1 26 / j2 21	
;
; $020C 8765FFFF
;  8 -> Tilt			j2 10		
;  7 -> Game over		j2 11		
;  6 -> High score to date	j2 23		
;  5 -> Ball in play 		j2 22		
;
; 	
; mata hari rules:
;
; dip switches used dip 23 , top saucer starts at 3000 or at 2x
;
;hit upper saucer
;dip sw 23 off
;3000, 2x and 3000 Punkte, 3x and 3000,5x and 3000,count bonus down, start at 3000
;dip sw 23 on
; 2x and 3000 Punkte, 3x and 3000,5x and 3000,count bonus down, start at 2x

;
; right outlane:
; 1000 points and if  3 x light  50'000 
;
; light outlane:
;1000 points and if 2 x light  50'000 
;
; A + B Switch
; 1000 (light left bumper),2000 (light right bumper),3000,4000,5000,extra ball,special,special
;
; drop target down 500 p and one bonus , if all down 50'000 , second time special

; mata hari lamp schemas
; $0200 8765FFFF
;  8 -> bonus 4k	q57	J3 1	
;  7 -> bonus 3k	q36	j3 26
;  6 -> bonus 2k	q29	j1 1
;  5 -> bonus 1k	q14 	j1 18
; $0201 8765FFFF
;  8 -> bonus 8k	q50	j3 12
;  7 -> bonus 7k	q38	j3 25
;  6 -> bonus 6k	q27	j1 9
;  5 -> bonus 5k	q12	j1 19
; $0202 8765FFFF
;  8 -> drop target spec q51	j3 15
;  7 -> bonus 20k	q44	j3 19
;  6 -> bonus 10k	q28	j1 8
;  5 -> bonus 9k	q13	j1 17
; $0203 8765FFFF
;  8 -> a target (2) 	q54	j3 11
;  7 -> b target (2)	q49	j3 17
;  6 -> n/u		q35	j1 3
;  5 -> n/u		q8	j1 23
; $0204 8765FFFF
;  8 -> n/u	 	q55	j3 9
;  7 -> n/u	 	q48	j3 16
;  6 -> n/u		q34	j1 2
;  5 -> n/u		q9      j1 14
; $0205 8765FFFF
;  8 -> ab value 4k	q16	j3 3
;  7 -> ab value 3k	q37	j3 23	
;  6 -> ab value 2k	q22	j1 10
;  5 -> ab value 1k	q10	j1 15
; $0206 8765FFFF
;  8 -> n/u		q59	j3 4
;  7 -> ab value spec	q32	j3 27
;  6 -> ab value extra	q26	j1 7
;  5 -> ab value 5k	q11	j1 16
; $0207 8765FFFF
;  8 -> lt outlane 50k	q58	j3 2
;  7 -> rt outlane 50k	q20	j1 13
;  6 -> n/u		q25	j1 6	
;  5 -> n/u		q4	j1 28
; $0208 8765FFFF
;  8 -> lt bottom bumpe	q56	j3 10
;  7 -> rt bottom bumpe	q42	j3 21
;  6 -> n/u		q24	j1 5
;  5 -> n/u		q1	j1 24
; $0209 8765FFFF
;  8 -> 2 x potential	q46	j3 18
;  7 -> 3 x potential	q41	j3 20
;  6 -> 5 x potential	q17 	j1 11
;  5 -> n/u		q2	j1 25
; $020A 8765FFFF
;  8 -> credit indicator	j3 13			
;  7 -> S.P. SHOOT AGAIN	j3 22			
;  6 -> MATCH			j2  8 / j1  4		
;  5 -> SHOOT AGAIN		j1 26 / j2 21		
; $020B 8765FFFF
;  8 -> 2 x multi 	q30	j3 14			
;  7 -> 3 x multi	q39	j3 24			
;  6 -> 5 x multi	q21	j1 12 / j2 12			
;  5 -> n/u		q7	j1 27 / j2 13			
; $020C 8765FFFF
;  8 -> Tilt			j2 10		
;  7 -> Game over		j2 11	
;  6 -> High score to date	j2 23				
;  5 -> Ball in play 		j2 22			
; $020D 8765FFFF
;  8 -> n player 4	q43	j2 7			
;  7 -> n player 3	q30	j2 6		
;  6 -> n player 2	q18	j2 20		
;  5 -> n player 1	q5	j2 16			
; $020E 8765FFFF
;  8 -> player up 4	q45	j2 1	
;  7 ->	player up 3	q31	j2 2				
;  6 -> player up 2	q19	j2 15			
;  5 -> player up 1	q6	j2 14				
;
	org	$0047
;!!! 8 bit Variable here...(from $47 until $5A)
multibl:		
	db	$00
skillbl:
	db	$00
; variable XUSC1 could be used (will be counted down to zero...)
; variable XBON could be used for bonus
;!!!
	org	$026C
;!!! 4 bit variables here...(from $26C to $28E) 
; 4 bit means the lower for bits of a variable are always one
; a store of 00 in a variable declared here and a read of this variable results in 0f
multi:
	db	$00
blinknr:
	db	$00
skill:
	db	$00

;!!!
	org	$02AF
;!!! 4 bit Variable here...(until $2FF) 
; parameters who can be set during selfttest can be declared here
;!!!
	org	$1000
c1	db	$00		; checksum byte, leave it
	org	$1001

;
	mainen1	spin,sgame,egame,addpl,splayer,stplayer,balls,fcount
;
; parameter 4 and 5 is the version number 
; parameter 6 is the lamp number of the solenoid expander if you use more then 15 coils
;
	mainen2	zcross1,zcross2,zcross3,7,0,00
;	
	mainen3	afterdi,bscor,addpends,addscor,aftersco,knock,digitup,makeso,killso
;
;!!! start coding here
; all solenoids must be defined once with a soldef
; type = 100	norm	(rest)	
; type = 101	perm	(coin lockout=1,flipperenable=4)
; type = (swnr)	Quick	(bumper)
;
; you find out the solenoid number if you study the solenoid schema of the pinball
; 	
; K1 relais
	soldef	4,101	
; coin lockout
	soldef  1,101
;
; saucer	Q2
	soldef  0,100
; chime 10	Q1
	soldef  1,100
; chime 100	Q5
	soldef  2,100
; chime 1000	q6
	soldef  3,100
; extra chime	q7 
	soldef	4,100
; knocker 	q3
	soldef  5,100
; outhole	q4
	soldef  6,100
; left botton bumper	q8
	soldef  7,38
; left top  bumper	q13		
	soldef  8,40
; right top bumper	q14		
 	soldef  9,39
; right bottom bumper		q9
	soldef  10,37
; left sling	q10
	soldef  11,36
; left drop target reset	q12
	soldef  12,100
; right sling	q11
	soldef  13,35
; right drop target reset	q16
	soldef  14,100
;
; all 40 (or 48) switches must be defined once
;
	; credit button
	swdef	06,swcredit
	; tilt
	swdef	07,swtilt
	; outhole switch
	swdef	08,swouthole
	; coin 2
	swdef	09,swcoin
	; coin 3
	swdef	10,swcoin
	; coin 1
	swdef	11,swcoin
	; slamtilt
	swdef	16,swlam
	; drop target
	swdef	17,checkdr
	; drop target
	swdef	18,checkdr
	; drop target
	swdef	19,checkdr
	; drop target
	swdef	20,checkdr
	; drop target
	swdef	21,checkdr
	; drop target
	swdef	22,checkdr
	; drop target
	swdef	23,checkdr
	; drop target
	swdef	24,checkdr
	; right inlane
	swdef	25,swinl
	; left inlane
	swdef	26,swinl
	; 10 points
	swdef	27,p10
	; switch b
	swdef   28,swb
	; switch a
	swdef   29,swa
	; switch b
	swdef   30,swb
	; switch a
	swdef   31,swa
	; saucer upper
	swdef	32,swsaucer
	; right outlane
	swdef	33,swrout
	; left outlane
	swdef	34,swlout
	; right sling
	swdef	35,p10
	; left sling
	swdef	36,p10
	; right button bumper
	swdef	37,swrbump
	; left button bumper
	swdef	38,swlbump
	; right upper bumper
	swdef	39,swbump1
	; left upper bumper
	swdef	40,swbump1
swrbump:
	gaoff	tilt
; is 1000 light on right button bumper ?
	laonq	48,give1t
; else here 100 points
swbump1:
	as100p	01
	clra
	rts
swlbump:
	gaoff	tilt
; is 1000 light on left button bumper ?
	laonq	88,give1t
; else here 100 points
	bra	swbump1
give1t:
; here 1'000 points
	as1tp	01
	clra
	rts	
swrout:
	gaoff	tilt
; is 50'000 light on right outlane ?
	laonq	47,give50t
; else here 1000 points
	bra	give1t
swlout:
	gaoff	tilt
; is 50'000 light on left outlane
	laonq	87,give50t
; else here 1000 points
	bra	give1t
give50t:
; here 50'000 points
	as10tp	05
	clra
	rts	
p10:		
	gaoff	tilt
; here 10 points
	as10p	01
tilt:
	clra
	rts
;
checkdr:	
	gaoff	tilt
; check all 8 drop target switches, if all targets down, reset, 50'000 points
; and light special or give special
; check all switches 17 - 24
	csw	17,checkop
	csw	18,checkop
	csw	19,checkop
	csw	20,checkop
	csw	21,checkop
	csw	22,checkop
	csw	23,checkop
	csw	24,checkop
; all targets down, reset target bank
	solon	12,10
	solon	14,10
; is special is already light ?
	laonq	82,checksp
; no, let us light special
	lampon  82
	jmp	give50t
checksp:		
; give freegame
	ldaa    #$07
	clrb
	rts
checkop:		; not all targets dropped
; score 500 points and add one bonus
	as100p	05
	jsr	addbo	; add one bonus
	clra
	rts
lightx:		; turn a b lights on
	lampon	83
	lampon	43
	rts
swinl:
	gaoff	tilt1	
; score 500 points and add bonus for left or right inlanes
	as100p	05
	jsr	addbo	; add one bonus
	clra
	rts
swa:		; a spotted
	gaoff	tilt1
; score 500 points if not a + B 
	ldaa	skill
	cmpa	#$FF
	bne	swa1
	laoffq	83,swa1
	bra	skillh	; we have a skill shoot
swa1:
	lampoff	83
	jsr	addbo	; add one bonus
	bra	swb5
swb:		; b spotted
	gaoff	tilt1
; score 500 points if not a + B 
	ldaa	skill
	cmpa	#$FF
	bne	swb1
	laoffq	43,swb1		
skillh:		
	clr	skill	; we made a skill shoot
; give two a + B because skillshoot is hit
	jsr	shiftab	; shift ab lights once
	jsr	shiftab	; shift ab lights once
	jsr	lightx	; light a + b
	clra
	rts
swb1;
	jsr	addbo	; add one bonus
	lampoff 43
swb5:
	laonq	43,swb9	
	laonq	83,swb9
; both lamps (a + b) are off, shift a + b once and relight a + B
	jsr	shiftab	; shift ab lights once
	jsr	lightx	; light a + b
	clra
	rts
swb9:		; a or b still light here 500 points
	as100p	05
tilt1:
	clra
	rts
swsaucer:		; upper saucer hit
	gaoff	sauc8
	jsr	addbo	; add one bonus
	jsr	addbo	; add one bonus
	jsr	addbo	; add one bonus	
; give 3000 points
	as1tp	03
	ldaa	multi
	anda	#$f0
	cmpa	#$00
	bne	sws1
	ldaa	#$08
sws1:
	cmpa	#$80	; 5 x is enought...
	beq	sauc9		
	asla		; increase multiplier
sauc2:
	staa 	multi
; lets wait a little...
	wait	10
sauc8:			; kick out ball	
	solon	00,0A
; clear switch to prefent double detection
	rsw	32	
	clra
	rts
sauc9:			; count down bonus after 5x ....
	staa 	multi
	jsr	dbonus
	bra 	sauc8
swouthole:	; ball in outhole, finish
	ldaa    #$01
	rts
swcredit:	; add one player
	ldaa    #$04
	rts
swcoin:		; always two credits with one coin
	jsr	sound3
	ldab 	#$02
	ldaa    #$07
	rts
swtilt:		; pinball is tilted
; throw out upper saucer
	solon	00,0A
	ldaa    #$05
	rts
swlam:		; slamtilt
	ldaa    #$06
	rts
;
; routines are activated in the following sequence
; power on 			-> spin
;				-> egame
; credit button pressed once	-> sgame
;				-> addpl  	a = 1
;				-> splayer 	a = 1
;				-> balls	a = 1, b = 00
; credit button pressed twice	-> addpl	a = 2
; ball hits score100		-> fcount	a = 0
; ball hits score100
; ball drains 		 
;				-> stplayer	a = 1
;				-> splayer	a = 2
;				-> balls	a = 2, b = 00
spin:		; coding for the pinball start (after power on)
	solon	00,0A
	clra
	rts
sgame:		; coding for the game start	(after credit button is pressed once, or power on)
	clra
	rts
egame:		; coding for the game end	(or power on)
		; reset ab bonus , prepare for attract modus
	jsr	resetab
	jsr	resetb
	jsr	lightx
	clr	multi
	clr 	skill	; reset skill shoot
	clra
	rts
addpl:		; coding for adding one player (repeated for every player, reg a holds player number)
		; a = 1 -> 1 player
		; a = 2 -> 2 player
		; a = 3 -> 3 player
		; a = 4 -> 4 player
	ldaa	X020D	; show number of players...
	cmpa	#$FF
	bne	addpl1
	ldaa	#$EF	; show player 1 can play
	bra	addpl2
addpl1:
	asla		; show player 2 - 4 can play
addpl2:
	staa	X020D
	clra
	rts
splayer:	; coding when a ball is served to the player reg a holds player, only once per player, x holds player 
		; save area max 16 bytes (2c0 - 2ff)
	cmpa	#$04
	bne	splayer3
	ldaa	#$7F
	bra	splayer9
splayer3:
	cmpa	#$03
	bne	splayer2
	ldaa	#$BF
	bra	splayer9
splayer2:
	cmpa	#$02
	bne	splayer1
	ldaa	#$DF
	bra	splayer9
splayer1:
	ldaa	#$EF
splayer9:
	staa	X020E	; lights player number in backglass
	clra
	rts	
stplayer:	; coding when a ball drains  reg a holds player number , 
		; do here bonus count  x holds player
		; save area max f bytes (2c0 - 2ff)
	gaoff	tilt2
	jsr	dbonus
tilt2:
	clra
	rts
balls:		; coding when a ball is served to a player, reg a holds player number, reg b holds reason
		; b = X0 -> normal ball
		; b = X1 -> we play an extra ball
		; b = X2 -> new ball (due to multiball lock)
		; scored with this ball ( x = 0 -> no, x= 8 -> yes)
		; do here: activate outhole solenoid, reset lamps for the next ball
	ldaa	#$FF
	staa	skill	; set skill shoot active
	clr	multi
	dip1724
	bita	#$40
	beq	balls9
			; dip 23 is on, let us start with 3000 and pot 2x lit
	ldaa	#$10
	staa	multi
balls9:
	ldaa	#$FF	; switch off outlanes (50'000)
	staa	X0207
	; switch off special
	lampoff 82
	; reset target bank
	solon	12,10
	solon	14,10
	jsr	resetab
	jsr	resetb
; turn on lamp a (or was it lamp b?)
	lampon	83
; activate outhole	
	solon	06,0A
; reset outhole switch to prevent dobble detection...
	rsw	08
	clra
	rts
fcount:		; first score for this ball, reg a holds player number
	ldaa	skill	
	cmpa	#$FF
	bne	fcount9
; skill shoot not successfull
	jsr	lightx	; light a + b
fcount9:
	clr 	skill	; reset skill shoot
	clra
	rts
zcross1:
		; update your timers here beginn of zerocross (120 times per second)
	clra
	rts
zcross2:	; additional aux lamp board is updated if a not equ 0
	clra
	rts
zcross3:	; after fast react solenoid routine
	clra
	rts
afterdi:	; display interrupt (called for one character) could be used for addressing 6th display
		; a contains the display digit 
	clra
	rts
bscor:		; before add a score reg a holds player number
	clra
	rts
addscor:	; add the score reg a holds play number
	clra
	rts
addpends:	; before adding a pending score (one digit one number a call, reg a holds player number)
	clra
	rts
aftersco:	; after add a score (reg a holds play number) 
		; do here periodic things during game or attract modus
	gaatt	aftersc1
; don't do it in the attract modus
	jsr	setmp
aftersc1:
	ldaa	skill	
	cmpa	#$FF
	bne	aftersc9
; if skillshoot is active
	inc	skillbl
	ldaa	skillbl
	cmpa	#$ff
	bne	aftersc9
	laonq   43,aftersc5
; toggle lamps a + b
	lampoff	83
	lampon	43
	bra	aftersc9
aftersc5:
	lampon	83
	lampoff	43
aftersc9:
	clra
	rts
knock:		; freegame activate the knocker
	solon	5,0C
	clra
	rts
digitup:	; start update a digit during scoring
		; digitup   start update digit during scoring (Reg a Loaded a= 0 + 10, a = 1 + 100, a = 2 + 1000...)
		; perfect place to activate chimes...
	cmpa	#$00	; score 10 points	(old 3)
	bne	digit2
	solon	01,00
digit2:
	cmpa	#$01	; score 100 points	(old 4)
	bne	digit3
 	solon	02,00
digit3:
	cmpa	#$02	; score 1000 points	(old 5)
	bne	digit4
	solon	03,00
digit4:
	cmpa	#$03	; score 10000 points	(old 6)
	bne	digit9
	solon	04,00
digit9:
	clra
	rts
makeso:		; make sound reg a  > 0 application frame wants sound
		; a = 1 tilt
		; a = 2 search match
		; a = 3 game over
		; a = 4 testswitch 1
		; a = 5 testswitch 2
		; a = 6 game start
		; a = 7 add player
		; a = 8 pinball start
	cmpa	#$03
	bne	makeso1
	jsr	sound1	; game sound game over
	jmp	makeso9
makeso1:
	cmpa	#$07
	bne	makeso9	
	jsr	sound2	; game sound add player
makeso9:
	clra
	rts
killso:		; stop running sound
	clra
	rts
setmp:		; this routines light 2 x, 3 x ,5 x for saucer and  the bonus ladder
		; multi = b'00001111' light 3000 (is GI no action...)
		; 	  b'00011111' light 3000, pot 2 x
		; 	  b'00101111' light 3000, pot 3 x, 2x
		; 	  b'01001111' light 3000, pot 5 x, 3x
		;	  b'10001111' light 3000, blink pot 2 , pot 3, pot 5 , 5x
	ldaa	multi
	anda	#$f0
	bne	setmp1	
	ldaa	#$ff	; light 3000 (is GI no action...)
	staa	X0209
	staa	X020B
	bra	setmp9
setmp1:
	bita	#$10
	beq	setmp2
		; 	  b'00011111' light 3000, pot 2 x
	ldaa	#$ff	; light 3000 (is GI no action...)
	staa	X020B
	ldaa	#$7f
	staa	X0209
	bra 	setmp9
setmp2:
	bita	#$20
	beq	setmp3
		; 	  b'00101111' light 3000, pot 3 x, 2x
	ldaa	#$7f	
	staa	X020B
	ldaa	#$bf
	staa	X0209
		; light 50'000 left outlane
	lampon	87
	bra	setmp9
setmp3:
	bita	#$40
	beq	setmp4
		; 	  b'01001111' light 3000, pot 5 x, 3x
	ldaa	#$bf	
	staa	X020B
	ldaa	#$df
	staa	X0209	
		; light 50'000 right outlane
	lampon	47

	bra	setmp9
setmp4:
	bita	#$80
	beq	setmp9
		;	  b'10001111' light 3000, blink pot 2 , pot 3, pot 5 , 5x
	ldaa	#$df	
	staa	X020B
	inc	multibl
	ldaa	multibl
	cmpa	#$FF
	bne	setmp9	; update blink slowly (only every 16 time...)
	ldaa	X0209
	cmpa	#$ff
	beq	setmp5
	sec	
	rora
	cmpa	#$EF
	beq	setmp5
	staa	X0209
	bra	setmp9
setmp5:
	ldaa	#$7f
	staa	X0209
setmp9:
	rts

attract:	; only activated during attract modus
; you can use XATT1,XATT2,XATT3,XATT4 (8 bit variables) here for the attract modus
	inc	XATT1	; timer 00 -> 01 ->...-> ff
	ldaa	XATT1
	cmpa    #$FF
	bne	att1
	jsr	shiftab	; shift ab lights once
	jsr	shiftb	; shift bonus ladder
att1:
	inc 	XATT2
	ldaa	XATT2
	cmpa	#$b0
	bne	attx
	clr	XATT2
	ldaa	#$FF	; blink it  A + B
	eora	X0203
	staa	X0203
	inc	blinknr
	ldaa	blinknr
	cmpa	#$0F
	bne	att2
	ldaa	#$FF
	staa	X0207
	staa	X020B
	lampoff	4A
attx:	
	jmp	att9
att2:
	cmpa	#$1F
	bne	att3
; light left outlane
	lampon	87
	lampoff	4A
	bra	att9
att3:
	cmpa	#$2F
	bne	att4
; light 3 X multi
	lampoff	87
	lampon	4B
	bra	att9
att4:
	cmpa	#$3F
	bne	att5
; light 2 x mulit
	lampoff	4B
	lampon	8B
	bra	att9
att5:
	cmpa	#$4F
	bne	att6
; light  5 x
	lampoff	8B
	lampon	2B
	bra	att9
att6:
	cmpa	#$5F
	bne	att80
; light extra
	lampoff	2B
	lampon	4A
	bra	att9
att80:
; light right outlane
	lampoff	4A
	lampon	47
	ldaa	#$FF
	staa	blinknr
	bra	att9
att9:	
	clra
	rts

resetb:		; reset bonus table for attract
	clr	XBON
	inc	XBON
	ldaa	#$EF
	staa	X0200
	ldaa	#$FF
	staa	X0201
	staa	X0202
	staa	X0208
	rts	

shiftb:		; shift bonus lights one
	ldaa	X0200
	asla	
	staa	X0200
	bcc	shiftb3
	ldaa	X0201
	asla
	staa	X0201
	bcc	shiftb4
	ldaa	X0202	
	asla
	bita	#$20
	beq	shiftb5
	staa	X0202
	rts
shiftb3:
	ldaa	#$EF
	staa	X0201
	rts
shiftb4:
	ldaa	#$EF
	staa	X0202
	rts
shiftb5:
	bsr	resetb
	rts


resetab:		; reset ab table
	ldaa	#$EF
	staa	X0205		; b'11101111'
	ldaa	#$FF
	staa	X0206
	rts	

shiftab:		; add one to ab	used during attract and game !
 	gaatt	shift1
 ; do scoring only during game
 	ldaa 	X0205
	bita	#$10
	bne	shiftn1
; light left bumper
	lampon	88
	ldaa	#$01	; score 1000
	bra	shiftsc
shiftn1:
	bita	#$20
	bne	shiftn2
; lighr right bumper
	lampon	48
	ldaa 	#$02	; score 2000
	bra	shiftsc
shiftn2:
	bita	#$40
	bne	shiftn3
	ldaa 	#$03	; score 3000
	bra	shiftsc
shiftn3:
	bita	#$80
	bne	shiftn4
	ldaa 	#$04	; score 4000
	bra	shiftsc
shiftn4:
 	ldaa 	X0206
	bita	#$10
	bne	shiftn5
	ldaa 	#$05	; score 5000
	bra	shiftsc
shiftn5:
	bita	#$20	; give extra ball
	bne	shiftn6
	giveex
	bra	shift1
shiftn6:
; give special
	givesp
	bra	shift1
shiftsc:		; score points...
	as1tp
shift1:
	ldaa	X0205
	asla	
	staa	X0205
	bcc	shift4
	ldaa	X0206
	asla
	staa	X0206
	bita	#$80	; 
	beq	shift5
shift3:
	rts
shift4:			
	ldaa	#$EF
	staa	X0206
	rts
shift5:
; do something other when we are in game....
 	gaatt	shift6
; set score back to special 
	ldaa	#$BF
	staa	X0206
	rts
shift6:
; reset a b lights (only during attract modus...)
	bsr	resetab
	rts
blamp:
	dw	lamptab
; a= gh, bits #gh off at add (0200 + h) lamp on, b =d est, x =dest
; holds two lamps for each bonus in the structur for lampon / lampoff 
lamptab:
	db	$00, $00		; bonus 0
	db	$10, $00		; bonus 1
	db	$20, $00		; bonus 2
	db	$40, $00		; bonus 3
	db	$80, $00		; bonus 4
	db	$11, $00		; bonus 5
	db	$21, $00		; bonus 6
	db	$41, $00		; bonus 7
	db	$81, $00		; bonus 8
	db	$12, $00		; bonus 9
	db	$00, $22		; bonus 10
	db	$10, $22		; bonus 11
	db	$20, $22		; bonus 12
	db	$40, $22		; bonus 13
	db	$80, $22		; bonus 14
	db	$11, $22		; bonus 15
	db	$21, $22		; bonus 16
	db	$41, $22		; bonus 17
	db	$81, $22		; bonus 18
	db	$12, $22		; bonus 19
	db	$00, $42		; bonus 20
	db	$10, $42		; bonus 21
	db	$20, $42		; bonus 22
	db	$40, $42		; bonus 23
	db	$80, $42		; bonus 24
	db	$11, $42		; bonus 25
	db	$21, $42		; bonus 26
	db	$41, $42		; bonus 27
	db	$81, $42		; bonus 28
	db	$12, $42		; bonus 29
	db	$22, $42		; bonus 30

findl:				; find an entry in the lamptab based on variable xbon
	ldx	blamp
	ldaa	XBON
findl1:
	cmpa    #$00
	beq	findl2
	inx	
	inx
	deca
	bra 	findl1
findl2:
	rts

addbo:		; add one to bonus (maximum 30) and light lamps
	ldaa	XBON
	cmpa	#$1D		; max bonus 30
	bhi	addb9
	bsr	findl		; find old lamps
	ldaa	$01,x
	psha			; save 10 or 20 lamps on stack
	ldaa	$00,x		; find old lamp and switch it off
	lampoff			
	inc	XBON
addb8:
	bsr	findl
	ldaa	$01,x
	psha			; save 10 or 20 lamp on stack
	ldaa	$00,x		; switch on new lamps
	lampon		
	pula			; get new lamp 
	pulb			; get old lamp
	cba
	beq	addb9		; both lamps are the same, don't do anything...
; else switch the one off the other one on
	lampon	,save
	tba
	lampoff
addb9:
	rts	
dbonus:			; count down entire bonus
	ldaa	XBON
	cmpa	#$00
	beq	dbonus9
	bsr	decbo
	wait 	10
	bra	dbonus
dbonus9:
	clr	multi
	dip1724
	bita	#$40
	beq	dbonus10
			; dip 23 is on, let us start with 3000 and pot 2x lit
	ldaa	#$10
	staa	multi
dbonus10:
	rts
	
decbo:		; count bonus down to zero, light lamps and add score
	ldaa	XBON
	cmpa	#$00
	beq	decb9
	bsr	findl		; find old lamps
	ldaa	$01,x
	psha			; save 10 or 20 lamps on stack
	ldaa	$00,x		; find old lamp and switch it off
	lampoff			
	dec	XBON
	; 2 x lit ?
	laonq	8b,score2t
	; 3 x lit ?
	laonq	4b,score3t
	; 5 x lit ?
	laonq	2b,score5t
	ldx	#$1000
	bra	scoreit
score5t:
	ldx	#$5000
	bra	scoreit
score3t:
	ldx	#$3000
	bra	scoreit
score2t:
	ldx	#$2000
scoreit:
	as100
	ldaa	#$02
	jsr	digitup	; make sound
	bra	addb8
decb9:
	rts
sound1:
	solon	02,00
	wait	0C
	; old 32
	solon	03,00
	wait    14
	; old 53
	solon	01,00
	wait	0C
		; old 31
	solon	01,00
	wait	0C
		; old 31
	solon	02,00
	wait    14
		; old 52
	solon	04,00
	wait	0C
		; old 34
	solon	04,00
	wait	0C
		; old 34
	solon	01,00
	wait    14
		; old 51
	solon	01,00
	wait	0C
		; old 31
	solon	01,00
	wait	0C
		; old 31
	solon	01,00
	wait 	1c
		; old 71
	rts
sound2:
	solon	04,00
	wait    14
		; old 54
	solon	01,00
	wait    14
		; old 51
	solon	02,00
	wait    14
		; old 52
	solon   03,00
	wait	18
		; old 63
	solon	03,00
	wait	0C
		; old 33
	solon	03,00
	wait	0C
		; old 33
	solon   03,00
	wait	10
		; old 43
	solon   02,00
	wait	18
		; old 62
	solon	02,00
	wait	0C
		; old 32
	solon	02,00
	wait	0C
		; old 32
	solon	02,00
	wait    10
		; old 42
	solon	01,00
	wait    14
		; old 51
	solon	02,00
	wait    14
		; old 52
	solon	01,00
	wait    14
		; old 51
	solon	04,00
	wait 	1c
		; old 74
	rts	
sound3:
	solon	04,00
	wait	0C
		; old 34
	solon	01,00
	wait	0C
		; old 31
	solon	02,00
	wait	0C
		; old 32
	solon	03,00
	wait    14
		; old 53
	solon	02,00
	wait	0C
		; old 32
	solon	03,00
	wait 	1c
		; old 73
	rts
;!!! end coding
	org	$17FF
 	db	$00
;	parameter 2 is 6 or 7 digit displays
; 	parameter 3 is the additional adress if you have more than 40 switches
	mainen4	attract,6,00
;
	org	u2rest
;!!! continue coding here
	org	$57FF
c6	db	$00
