	nolist
	org	$0000
; Pinball construction kit version 8 for early ballys and early sterns
; by okaegi
;	XCHAR	; digit to display	*int*
XCHAR:			
	db	$00
;	X0001-X0004	number *int*
X0001:
	db	$00
X0002:
	db	$00
X0003:
	db	$00
X0004:
	db	$00
;	X0005-X0008	number	*int*
X0005:
	db	$00
X0006:
	db	$00
X0007:
	db	$00
X0008:
	db	$00
;	XJMPS2   ; temp for switch matrix	*int*
XJMPS2:
	db	$00
;	XJMPS22   ; temp for switch matrix	*int*
XJMPS22:
	db	$00
X000B:			; ball number/player up  *int*
	db	$00
X000C:			; actual playerer 	*int* 
	db	$00
XATT1:			; free during attract
	db	$00
XATT2:			; free during attract
	db	$00
XATT3:			; free during attract
	db	$00
XATT4:			; free during attract
	db	$00
	
;	$000D	; player 1 flag
;	$000E	; player 2 flag
;	$000F	; player 3 flag
;	$0010	; player 4 flag
;       X0011	; pending 10 for score;
X0011:					;*int *
	db	$00
;       X0012	; pending 100 for score
X0012:					;*int*
	db	$00
;	X0013	; pending 1000 for score
X0013:					;int*
	db	$00
;	X0014	; pending 10000 for score
X0014:					;*int*
	db	$00
;	X0015	; pending 100000 for score
X0015:					;*int*
	db	$00
;	X0016	; pending 1000000 for score
X0016:					;*int*
	db	$00
	; system flags
XFLAG:			; 	*int*
	db	$00
;	oraa	#$01	; tilted 
;	oraa	#$02	; test switch pressed
;	oraa	#$10	; momentary solenoid active 
;	oraa	#$40	; this ball is an extra ball
;	oraa	#$20	; game is over
;	oraa	#$80	; we scored with this ball 

X0018:			; adress of next charter for display (within player one 21e  to 224 )	*int*	
	db	$00, $00
XBON:			; Bonus counter	* free *
	db	$00
X001B:			; 		* free *
	db	$00
XU10FL:			; XU10FL = FF U10 PB0 PB7 as Output Or save for cabinet switches ?	*int*
	db	$00
XMATCHC:		; zero cross counter 00 - ff X001D	*int*
	db	$00
XSOLC:			; solenoid timer X001E	*int*
	db	$00
XUSC0:			; user timer (jsr ZWAIT) X001F	*int for wait macro*
	db	$00
XSCC:			; score update counter X0020	*int*
	db	$00
XUSC1:			; free user time  X0021	*user free ***
	db	$00
XATTRC2:			; attract modus timer X0022 X0023 *int*
	db	$00, $00
XMATCHD:		; Match counter (10 -90)	*int*
	db	$00
X0025:			; which display should blink now... *int*
	db	$00
XSTDBC:			; self test debounce counter X0026	*int*
	db	$00
XCLAUD:			; clear audit requested	*int* *useable for game*
	db	$00
X0028:			; temp storage X *int*
	db	$00, $00
X002A:			; adress for testmode	*int*
	db	$00
X002B:
	db	$00
;	X002C   ; pointer to the actual adress of the player (in scoretable)
;	X002E   ; pointer to player flag (one byte) 
X002C:			; *int*
	db	$00, $00
X002E:			; *int*
	db	$00, $00
X0030:			; * free **				* for sound card *
	db	$00, $00
X0032:			; sound table pointe (snd cmd 02)	* for sound card *
	db	$00, $00
X0034:			; sound disable timer			* for sound card *
	db	$00
;	X0035	; Switch Matrix 1
;	X0036	; Switch Matrix 2
;	X0037	; Switch Matrix 3
;	X0038	; Switch Matrix 4
;	X0039	; Switch Matrix 5
;	X003A	; Switch Matrix 6
;
;	X003B   ; Switch Matrix 1 (save 1)
;	X003C	; Switch Matrix 2 (save 1) 	
;	X003D	; Switch Matrix 3 (save 1) 
;	X003E	; Switch Matrix 4 (save 1)
;	X003F	; Switch Matrix 5 (save 1)
;	X0040	; Switch Matrix 6 (save 1)
;
;	X0041   ; Switch Matrix 1 (save 2)
;	X0042	; Switch Matrix 2 (save 2) 	
;	X0043	; Switch Matrix 3 (save 2) 
;	X0044	; Switch Matrix 4 (save 2)
;	X0045	; Switch Matrix 5 (save 2)
;	X0046	; Switch Matrix 6 (save 2)
X0035:			; *int*
	db	$00
X0036:			; *int*
	db	$00
X0037:			; *int*
	db	$00
X0038:			; *int*
	db	$00
X0039:			; *int*
	db	$00
X003A:			; *int*
	db	$00
X003B:			; *int*
	db	$00
X003C:			; *int*
	db	$00
X003D:			; *int*
	db	$00
X003E:			; *int*
	db	$00
X003F:			; *int*
	db	$00
X0040:			; *int*
	db	$00
X0041:			; *int*
	db	$00
X0042:			; *int*
	db	$00
X0043:			; *int*
	db	$00
X0044:			; *int*
	db	$00
X0045:			; *int*
	db	$00
X0046:			; *int*
	db	$00
; define the stack area...
	org	$005A
	db	$00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
;
;
; stack usage (start at 7f down to 5A):
; 2 bytes per jsr
; 7 bytes nmi (not relevant, only testmode...)
; 7 byte display interrupt
; 7 byte zero cross interrupt
; -> 14 byte blocked
; real stack 0x71 - 0x60 -> 0x12 byte -> 18 bytes -> 9 subroutines stacked are possbile
	org	$0080
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
pu10A0:		
; 0 - 4 playfield switch strobe
; 0 - 1	cabinet switch strobe
; 5 - 7 dip strobe (5 -> 1 - 8, 6 -> 9 - 16, 7, 17 -24)
; 0 - 3 Lamp adress
; 4 - 7 lamp data
; 0 - 3 Display Latch (display number)
; 4 - 7 Display segment data (bcd)
; ca1 (inp) selft test switch
; ca2 Display latch / blanking strobe 
	db	$00
pu10AC:
	db	$00
pu10B0:
; 0 - 7 playfield switch return
; 0 - 7 cabinet switch return
; cb1 (inp) zero cross
; cb2   dip strobe 25 - 32 / Lamp #1 Strobe
	db	$00
pu10BC:
	db	$00, $00, $00, $00
	db	$00
pu11A0:
; 0 display blanking
; 1 Sound E and 7 digit
; 2 - 7 digit 6 - 1
; ca1 (inp) display interrupt
; ca2 lamp strobe 2 / diag led
	db	$00
pu11AC:
	db	$00
pu11B0:
; 0 - 3 Momentary solenoid / sound a - d
; 4 - 7 Cont. Solenoid  / additional Hardware (switch 40 -48 , display latch)
; cb1 (inpu) j5 connector (aid)
; cb2 sound / solenoid select

	db	$00
pu11BC:
	db	$00
; 200 - 20f 				* Lamp board *
; a cleared bit means 	-> lamp is off
; a set bit means 	-> lamp is on
	org	$0200
X0200:  
	db	$00
X0201:
	db	$00
X0202:
	db	$00
X0203:
	db	$00
X0204:
	db	$00
X0205:
	db	$00
X0206:
	db	$00
X0207:
	db	$00
X0208:
	db	$00
X0209:
	db	$00
; $020A 8765FFFF	predefined lamp
;  8 -> credit indicator	j3 13		
;  7 -> S.P. SHOOT AGAIN	j3 22		
;  6 -> MATCH			j2 8  / j1 4	
;  5 -> SHOOT AGAIN		j1 26	/ j2 21	
X020A:
	db	$00

X020B:
	db	$00
;
; $020C 8765FFFF	predefined lamp
;  8 -> Tilt			j2 10		
;  7 -> Game over		j2 11		
;  6 -> High score to date	j2 23		
;  5 -> Ball in play 		j2 22		
X020C:
	db	$00

X020D:
	db	$00
X020E:
	db	$00
; 20f - 21d 				* aux lamp board memory area *
X020F:
	db	$00
X0210:
	db	$00
X0211:
	db	$00
X0212:
	db	$00
X0213:
	db	$00
X0214:
	db	$00
X0215:
	db	$00
X0216:
	db	$00
X0217:	
	db      $00
X0218:
	db	$00
X0219:
	db	$00
X021A:
	db	$00
X021B:
	db	$00
X021C:
	db	$00
X021D:
	db	$00
X021E:
	db	$00, $00, $00, $00
	db	$00, $00
X0224:
	db	$00
X0225:
	db      $00, $00, $00
	db	$00, $00, $00
X022B:
	db	$00, $00, $00, $00
	db	$00, $00, $00
X0232:
	db	$00, $00, $00, $00
	db	$00, $00, $00
X0239:
	db	$00
X023A:
	db	$00
X023B:
	db	$00
X023C:
	db	$00
X023D:
	db	$00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
XD14	db	$00
XD58 	db	$00
XD912	db	$00
XD1216	db	$00
XD1720	db	$00
XD2024 	db	$00
XD2528	db	$00
XD2832 	db	$00
	org	$028f
X028F:
	db	$00
X0290:
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00, $00, $00, $00
	db	$00
X02AD:
	db	$00
X02AE:
	db	$00


; jump table *kernel*
qnr	= 	0
bsw40	=	0
bsw32	= 	0
bsw24	= 	0
bsw16	=	0
bsw08	=	0

yjump   =	$5801
yswtaba	=	$5001
; switch tables
ysoltaba =	yswtaba+2*48
; normal solenoids (0 - 14), behind expander (15 - 30)
ysoltabp =      ysoltaba+32
; permanent solenoids (4)
ysoltabq =	ysoltabp+4
; quick solenoids described here
yvectaba =      ysoltabq+41
;
solon	macro	sol,time,save
;
; turn solenoid (sol) on 
;
; if time > 00 solenoid keeps on during 
; this period (sync)
; if time = 00 solenoid keeps on during 4 
; periods (async), will wait until no solenoid 
; is used
; if sol empty reg a is used
; if time empty reg b is used
; if saved filled a and b 
; pushed on stack
; Periods to use:
; knocker -> 0c
; kickout ball (outhole) -> 0a
; saucer -> 0c
; targetbank reset -> 10
; chimes -> 00
	nolist
	if      '\3' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	# (sol)
	nolist
	endif
	if	'\2' = '00'
	list
	jsr	ysolona
	nolist
	else
	if      '\2' != ''
	list
	ldab	#$time
	nolist
	endif
	list
	jsr	ysolon
	nolist
	endif
	if      '\3' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm
lampoff	macro	lamps,save
;
; turn lamp (lamps) off
;
; if lamps empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$lamps
	nolist
	endif
	list
	jsr	ylaoff
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm
lampofx macro	lamps,save
;
; turn lamp (lamps) off aux boad
;
; if lamps empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$lamps
	nolist
	endif
	list
	jsr	ylaoffx
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm

lampon	macro	lamps,save
;
; turn lamp (lamps) on
;
; if lamps empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$lamps
	nolist
	endif
	list
	jsr	ylaon	
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm
lamponx	macro	lamps,save
;
; turn lamp (lamps) on aux boad
;
; if lamps empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$lamps
	nolist
	endif
	list
	jsr	ylaonx	
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm


; central vectors

soldefi macro	sol,swnr
;
; internal use only
;
; define quick react solenoids (sol) in separate table
; a quick react solenoid is automatically pulsed
; after defined switch (swnr) was hit
; before game rom gets control
;
	nolist
adralt1	=	*
	org     ysoltabq+swnr
	list
	db	(sol)
	nolist
	if 	swnr > 40
error soldef: quick react with switch number > 40 not allowed
	endif	
	if 	swnr > 32
swnrq	=	swnr - 33
bsw40	=	bsw40 + (1 << swnrq)
	else
	if 	swnr > 24
swnrq	=	swnr - 25
bsw32	=	bsw32 + (1 << swnrq)
	else
	if 	swnr > 16
swnrq	=	swnr - 17
bsw24	=	bsw24 + (1 << swnrq)
	else

	if 	swnr > 8
swnrq	=	swnr - 9
bsw16	=	bsw16 + (1 << swnrq)
	else
swnrq 	=   	swnr - 1 
bsw08	=	bsw08 + (1 << swnrq)
	endif
	endif
	endif
	endif
	org	adralt1
	list
	endm



soldef	macro   nr,type
;
; declare solenoids (max 30)
;
; all solenoids must be defined once with a soldef
; first param (nr) is addr from U2 74ls154 on solenoid board, drives Q...
; if (nr) > 14 then solenoid expander is used...
; second param (type) defines coil usage
; (type) = 100	norm	(rest)	
; (type) = 101	perm	(coin lockout=1,flipperenable=4)
; (type) = (swnr)	Quick	(bumper)
;
	nolist	
adralt	=	*	
	org     ysoltaba + nr 
	if 	type < 100
	if	nr > 14
	list
error soldef: quick react behind solenoid expander not allowed
	endif	
; type = (swnr)	Quick
	list
sol\1	db	type
	soldefi	nr,type
	nolist
	else
	if 	type = 100
; type = 100	norm	
	if	nr > 29
	list
Error soldef: Solenoid number to high
	endif	
	list
sol\1	db	$E0
	nolist
	else
	if 	type = 101
; type = 101 	perm	
	if	nr = 1
	org     ysoltabp 
	list
solp\1	db	$bf		; coin lockout
	nolist
	endif
	if	nr = 2
	org     ysoltabp + 1
	list
solp\1	db	$7f	
	nolist
	endif
	if	nr = 3
	org     ysoltabp + 2
	list
solp\1	db	$ef	
	nolist
	endif
	if	nr = 4
	org     ysoltabp + 3
	list
solp\1	db	$df		; flipper k1 relais
	nolist
	endif
	endif
	endif
	endif
	org	adralt
	list
	endm

sonk1	macro	
;
; enable permanet solenoid k1 rel 
;
; 
	ldaa	#$df
	jsr	ysolpo
; restore A and B
	endm

soffk1	macro	
;
; disable permanet solenoid k1 rel 
;
	ldaa	#$df
	jsr	ysolpof
; restore A and B
	endm
sonco	macro	
;
; enable permanet solenoid coin lockout
;
	ldaa	#$bf		; coin lockout
	jsr	ysolpo
	endm

soffco	macro	
;
; disable permanet solenoid coin lockout
;
	ldaa	#$bf		; coin lockout
	jsr	ysolpof
	endm

sonp2	macro	
;
; enable permanent solenoid 2
;
	ldaa	#$7f	
	jsr	ysolpo
	endm

soffp2	macro	
;
; disable permanent solenoid 2
;
	ldaa	#$7f	
	jsr	ysolpof
	endm

sonp3	macro	
;
; enable permanent solenoid 3
;
	ldaa	#$ef	
	jsr	ysolpo
	endm

soffp3	macro	
;
; disable permanent solenoid 3
;
	ldaa	#$ef	
	jsr	ysolpof
	endm

swdef	macro	swnr,swadress
;
; define switch (swnr) with jsr subroutine (swadress)
;
; return code 
;
; if reg A = 0 , everything okay
; if reg A = 1, ball drained, 
;	if no score, serve nextball for this player
;	else if extraball (macro givex) was lit, 
;		serve next ball (jsr xball) for this player
; 	else if next player (stopplayer , player + 1,
;		 startplayer)
; if reg A = 2  ball locked serve next ball 
;		for multiball (jsr xball)
; if reg A = 4  add one player if possibile
; if reg A = 5  tilt this ball
; if reg a = 6  slamtilt entire pinball
; if reg a = 7  add credits number of credits in reg b
;		if b = 0 give one freegame with knocker
;
	nolist
	if 	swnr > 40
adr	=	48 - swnr + 40
	else
	if 	swnr > 32
adr	=	40 - swnr + 32
	else
	if 	swnr > 24
adr	=	32 - swnr + 24
	else
	if 	swnr > 16
adr	=	24 - swnr + 16
	else
	if 	swnr > 8
adr	=	16 - swnr + 8
	else
adr	=	8 - swnr 
	endif
	endif
	endif
	endif
	endif
adralt	=	*
	org 	yswtaba+adr*2
	list
sw\1	dw	swadress
	org	adralt
	endm
as100	macro	score,save
;
; add X to player score 000XXXX
;
; if score empty reg x is used
; if save filled a and b pushed stack
;
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldx	#$score
	nolist
	endif
	list
	jsr	ysc100
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm
as10t	macro	score,save
;
; add X to player score XXX0000
;
; if score empty reg x is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldx		#$score
	nolist
	endif
	list
	jsr	ysc10T
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm
as1mp	macro	score,save
;
; add a (1000000) to pending player score
;
; if score empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$score
	nolist
	endif
	list
	jsr	yscp1m
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm



as100tp	macro	score,save
;
; add a (100000) to pending player score
;
; if score empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$score
	nolist
	endif
	list
	jsr	yscp100t
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm
giveex	macro
;
; give extra ball 
;
	lampon	5A
	endm
givesp	macro
;
; give special (freegame)
;
	jsr	yspe
	endm

as10tp	macro	score,save
;
; add a (10000) to pending player score
;
; if score empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$score
	nolist
	endif
	list
	jsr	yscp10t
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm

as1tp	macro	score,save
;
; add a (1000) to pending player score
;
; if score empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$score
	nolist
	endif
	list
	jsr	yscp1t
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm

as100p	macro	score,save
;
; add a (100) to pending player score
;
; if score empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$score
	nolist
	endif
	list
	jsr	yscp100
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm

as10p	macro	score,save
;
; add a (10) to pending player score
;
; if score empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\2' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$score
	nolist
	endif
	list
	jsr	yscp10
	nolist
	if      '\2' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
	endm

wait	macro 	time
;
; wait until (time) reaches zero 
; (by zerocross)
;
	nolist
	if      '\1' != ''
	list
	ldab	#$time
	nolist
	endif
	list
	jsr	ywaitb
	endm

laonq	macro	lamps,jmpx,save
;
; check if lamp (lamps) is on jump if 
; on to (jmpx)
;
; if lamps empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\3' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$lamps
	nolist
	endif
	list
	jsr	ylach
	nolist
	if      '\3' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
; jump if lamp is on 
	beq	jmpx	
	endm
laoffq	macro	lamps,jmpx,save
;
; check if lamp (lmaps) is off jump if 
; off to (jmpx)
;
; if lamps empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\3' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$lamps
	nolist
	endif
	list
	jsr	ylach
	nolist
	if      '\3' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
; jump if lamp is off
	bne	jmpx	
	endm

laonqx	macro	lamps,jmpx,save
;
; check if lamp (lamps) is on on aux board jump if 
; on to (jmpx)
;
; if lamps empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\3' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$lamps
	nolist
	endif
	list
	jsr	ylachx
	nolist
	if      '\3' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
; jump if lamp is on 
	beq	jmpx	
	endm
laoffqx	macro	lamps,jmpx,save
;
; check if lamp (lamps) is off on aux boad jump if 
; off to (jmpx)
;
; if lamps empty reg a is used
; if save filled a and b pushed stack
	nolist
	if      '\3' != ''
	list
; Save A and B
	psha
	pshb
	nolist
	endif
	if      '\1' != ''
	list
	ldaa	#$lamps
	nolist
	endif
	list
	jsr	ylachx
	nolist
	if      '\3' != ''
	list
; restore A and B
	pulb
	pula
	nolist
	endif
	list
; jump if lamp is off
	bne	jmpx	
	endm

; get dip switches in a
dip18	macro
;
; get dip 08 - 01 in reg a
;
; $80 -> dip 08 on, $40 -> dip 07 on
	ldaa	XD14
	lsra
	lsra
	lsra
	lsra
	oraa	#$F0
	anda	XD58
	endm
dip916	macro
;
; get dip 16 - 09 in reg a
;
; $80 -> dip 16 on, $40 -> dip 15 on
	ldaa	XD912
	lsra
	lsra
	lsra
	lsra
	oraa	#$F0
	anda	XD1216
	endm
dip1724	macro
;
; get dip 24 - 17 in reg a
;
; $80 -> dip 24 on, $40 -> dip 23 on
	ldaa	XD1720
	lsra
	lsra
	lsra
	lsra
	oraa	#$F0
	anda	XD2024
	endm
dip2532	macro
;
; get dip 32 - 25 in reg a
;
; $80 -> dip 32 on, $40 -> dip 31 on
; dip switch used by pck:
; 32, 31 number of balls
;  set (1,1 -> 2, 1,0 -> 4, 0,1-> 5, 0,0 -> 3)
; 28 match on
; 27 display credits
; 26, 25 max credits (or freegame)
	ldaa	XD2528
	lsra
	lsra
	lsra
	lsra
	oraa	#$F0
	anda	XD2832
	endm
gaoff	macro	jmpyes
;
; check if game over or tilt is on 
; jump to (jmpyes) if one lamp is on
;
	ldab	X020C
	comb
	andb	#$C0
	bne	jmpyes
	endm
gaatt   macro	jmpyes
;
; check if game over is on 
; jump to (jmpyes) if on
;
	ldaa	X020C
	asla
	bpl	jmpyes	;  Jump if Game over lamp on
	endm
rsw	macro	swnr,save
;
; reset switch with number (swnr)
;
; if switch (swnr) is physically closed, 
; it will be activated again
; this routine should also be used after
; outhole was used and a permant closed
; switch was cleared
;
	nolist
	if      '\2' != ''
	list
; Save A
	psha
	nolist
	endif
	if 	swnr > 40
swnrx	=	swnr - 41
	list
	sei
	ldaa	X0040
	anda    # (255 - (1 << swnrx))
	staa	X0040
	ldaa	X0046
	anda    # (255 - (1 << swnrx))
	staa	X0046
	ldaa	X003A
	anda    # (255 - (1 << swnrx))
	staa	X003A
	cli
	nolist
	else
	if 	swnr > 32
swnrx	=	swnr - 33
	list
	sei
	ldaa	X003F
	anda    # (255 - (1 << swnrx))
	staa	X003F
	ldaa	X0045
	anda    # (255 - (1 << swnrx))
	staa	X0045
	ldaa	X0039
	anda    # (255 - (1 << swnrx))
	staa	X0039
	cli
	nolist
	else
	if 	swnr > 24
swnrx	=	swnr - 25
	list
	sei
	ldaa	X003E
	anda    # (255 - (1 << swnrx))
	staa	X003E
	ldaa	X0044
	anda    # (255 - (1 << swnrx))
	staa	X0044
	ldaa	X0038
	anda    # (255 - (1 << swnrx))
	staa	X0038
	cli
	nolist
	else
	if 	swnr > 16
swnrx	=	swnr - 17
	list
	sei
	ldaa	X003D
	anda    # (255 - (1 << swnrx))
	staa	X003D
	ldaa	X0043
	anda    # (255 - (1 << swnrx))
	staa	X0043
	ldaa	X0037
	anda    # (255 - (1 << swnrx))
	staa	X0037
	cli
	nolist
	else
	if 	swnr > 8
swnrx	=	swnr - 9
	list
	sei
	ldaa	X003C
	anda    # (255 - (1 << swnrx))
	staa	X003C
	ldaa	X0042
	anda    # (255 - (1 << swnrx))
	staa	X0042
	ldaa	X0036
	anda    # (255 - (1 << swnrx))
	staa	X0036
	cli
	nolist
	else
swnrx 	=   	swnr - 1
	list
	sei
	ldaa	X003B
	anda    # (255 - (1 << swnrx))
	staa	X003B
	ldaa	X0041
	anda    # (255 - (1 << swnrx))
	staa	X0041
	ldaa	X0035
	anda    # (255 - (1 << swnrx))
	staa	X0035
	cli
	nolist
	endif
	endif
	endif
	endif
	endif
	if      '\2' != ''
	list
; Restore A
	pula
	nolist
	endif
	list
	endm



csw	macro	swnr,jmpopen
;
; check if switch (swnr) is open
; if yes jmp to (jmpopen)
;
	nolist
	if 	swnr > 40
swnrx	=	swnr - 41
	list
; switch is closed when:
; x0040 is 1 and x0046 is 1 and X003a is 0
	ldaa	X003A
	coma
	anda	X0040
	anda	X0046
	bita    # (1 << swnrx)
	beq	jmpopen
	nolist
	else
	if 	swnr > 32
swnrx	=	swnr - 33
	list
	ldaa	X0039
	coma
	anda	X003F
	anda	X0045
	bita    # (1 << swnrx)
	beq	jmpopen
	nolist
	else
	if 	swnr > 24
swnrx	=	swnr - 25
	list
	ldaa	X0038
	coma
	anda	X003E
	anda	X0044
	bita    # (1 << swnrx)
	beq	jmpopen
	nolist
	else
	if 	swnr > 16
swnrx	=	swnr - 17
	list
	ldaa	X0037
	coma
	anda	X003D
	anda	X0043
	bita    # (1 << swnrx)
	beq	jmpopen
	nolist
	else
	if 	swnr > 8
swnrx	=	swnr - 9
	list
	ldaa	X0036
	coma
	anda	X003C
	anda	X0042
	bita    # (1 << swnrx)
	beq	jmpopen
	nolist
	else
swnrx 	=   	swnr - 1 
	list
	ldaa	X0035
	coma
	anda	X003B
	anda	X0041
	bita    # (1 << swnrx)
	beq	jmpopen
	nolist	
	endif
	endif
	endif
	endif
	endif
	list
	endm
mainen1	macro	startpin,startgame,endgame,addplayer,startplayer,stopplayer,xxball,firstcount
;
; First part of vector table
;
adralt	=       *
	org	yvectaba
xstartp	dw	startpin	;! adr "startpin
xstgp	dw	startgame	;! adr "startgame
xendgp	dw	endgame		;! adr "endgame
xaddpl	dw	addplayer	;! adr "addplayer
xstarp 	dw	startplayer	; ! adr "startplayer
xstoppl	dw	stopplayer	; ! adr "stopplayer	
xball	dw	xxball		; ! adr "Xball
xfirst	dw	firstcount	; ! adr "Firstcount
; vector tabel (all jsr)
; startpin when pinball is power on 
; startgame when a game is started or after power on 
; endgame when a game is finished (or cancled..) or after power on
; addplayer when one player is added by credit button
; startplayer when a ball is served to the player
; stopplayer when a ball drains for a player 
; xball when a ball is served to the player
; firstcount when the first points are counted for a ball (switch off extra ball lights...)
yvectabx =      *
	org	adralt	
	endm
mainen2	macro	zerocr,afterla,afterqu,uvers0,uvers1,expandla
;
; second part of vector table (must be after mainen1)
;
;
adralt	=       *
	org	yvectabx
xzero	dw	zerocr		;! adr "zerocr
xafla	dw	afterla		;! adr "afterla
xafqu	dw      afterqu		;! adr "afterqu
xvers	db      $\4F
 	db      $\5F
xexla	db	$\6		;! lampnr "expandla
; vector tabel (all jsr)
; zerocross when zero cross routine is activated after timer update, befor lamp update
; afterla when zero cross routine is activated after timer update, after lamp update(do here the aux)
; afterqu when zero cross routine is activated after timer update, after lamp update, after quick solenoid react
; xvers -> user version (player 1 display after start)
; xexla	-> lamp number froim solenoid expand 
yvectabx =      *
	org	adralt	
	endm

mainen3	macro	afterdi,befscor,addpends,addscor,aftersco,knock,digitup,makeso,killso
;
; third part of vector table (must be after mainen2)
;
;
adralt	=       *
	org	yvectabx
xafdi	dw	afterdi		;! adr "afterdi
xbesc	dw	befscor		;! adr "befscor
xaddps	dw	addpends	; adr "addpends
xaddsc	dw	addscor		;! adr "addscor
xafsc	dw	aftersco	;! adr "aftersco
xkno	dw	knock		;! adr "knock
xdig	dw	digitup		;! adr "digitup
xsou	dw	makeso		; ! adr "makeso
xksou	dw	killso		; adr "killso
; vector tabel (all jsr)
; afterdisp when display interrupt is activated after display update with one charakter (could be used for 6 display)
; befscor   befor adding a scoring
; addpends  add pending score (1 digit )
; addscor   add the score direct and check freegame
; afersco   after scoring, do the attract modus here
; knock     activate knocker
; digitup   start update digit during scoring (Reg a Loaded a= 0 + 10, a = 1 + 100, a = 2 + 1000...)
; makeso    start make sound (hook to sound card)
; killso    kill running sound
yvectabx =      *
	org	adralt	
	endm
mainen4	macro	attract,disp7,addsw
;
; forth part of vector table (must at the end of the program)
;
;
;
adralt	=       *
	org	yvectabx
xattra	dw	attract		;! adr "attract
; vector tabel (all jsr)
; attract if pinball is running in attract mouds
	nolist
	if	disp7 = 7
	list
; xdisp7 	=      	7 -> 7 digit displays / 7 digit scoring
XCHST	db      $02
XCHM	db      $01
XCHAD	db	$02, $24	
XCHOF	db	$f0
	nolist
	endif
	if	disp7 = 6
	list
; xdisp7	=      	6 -> 6 digit displays / 6 digit scoring
XCHST	db      $04
XCHM	db      $03
XCHAD	db	$02, $23
XCHOF	db	$ff
	nolist
	endif
	if	disp7 = 8
	list
;		=	8 -> 8 digit displays with hw adapter / 7 digit scoring
 error not done yet...
	nolist
 	endif
	list
XADSW	db	$\3	; adress additonal sw 40 - 48 (u11 pia b) "addsw
; XADSW 	=      	00	-> only 40 switch
;		=      	01	-> Strobe line for 40 - 48 
;		=	02 

;
; mask for quick react solenoids 
; switch detection
; 
	
bsw	=	bsw08 + bsw16 + bsw24 + bsw32 + bsw40
	nolist
	if	bsw = 0
	list
error: no quick react solenoid defined !!! 
this is not really possible
	nolist
	endif
	list
XB08	db	bsw08
XB16	db	bsw16
XB24	db	bsw24
XB32	db	bsw32
XB40	db	bsw40
;
yvectabx =      *
u2rest	=	*
	org	yjump
; jump table to link between app and kernel
xjump	equ	*	
; read dip switches	
ygetdip	=	*
	org 	*+3
; activate momentary solenoid a = solenr, b = wait times (sync)
ysolon =	*
	org 	*+3
; activate momentary solenoid a = solenr async (4 times)
ysolona =	*
	org 	*+3
; a= gh, set bits #gh off at add (0200 + h) lamp on, b =d est, x =dest
ylaon	=	*
	org 	*+3
; a= gh, set bits #gh on at add (0200 + h) lamp off, b =d est, x =dest
ylaoff	=	*
	org 	*+3
; Switch on Continue solenoids   DF=Coin Lock out BF = K1 Flipper enable
ysolpo 	= 	*
	org 	*+3
; Switch off Continue solenoids   DF=Coin Lock out BF = K1 Flipper enable
ysolpof =	*
	org 	*+3
; wait until reduce 3 times by irq	(XUSCO), b = dest
ywait3 	=	*
	org 	*+3
; wait until  reduce b times by irq	(XUSCO)
ywaitb	= 	*
	org 	*+3
; wait until  reduce XUSCO	 times by irq, b = dest
ywaitu 	=	*
	org 	*+3
; check if lamp is on a= gh, check bits #gh off at add (0200 + h) a is state , a = 00 lamp off, a = 01 lamp = on
ylach 	=	*
	org 	*+3
; add X to player score 000XXXX
ysc100 	=	*
	org 	*+3
; add X to player score XXX0000
ysc10T 	=	*
	org 	*+3
; add pending score (10)
yscp10 	=	*
	org 	*+3
; add pending score (100)
yscp100 =	*
	org 	*+3
; add pending score (1000)
yscp1t 	=	*
	org 	*+3
; add pending score (10000)
yscp10t	=	*
	org 	*+3
; add pending score (100000)
yscp100t =	*
	org 	*+3
; add pending score (1000000)
yscp1m	 =	*
	org 	*+3
; give special
yspe 	=	*
	org 	*+3
; a= gh, set bits #gh off at add (020F + h) lamp on aux boad, b =d est, x =dest
ylaonx	=	*
	org 	*+3
; a= gh, set bits #gh on at add (0200 + h) lamp off aux board, b =d est, x =dest
ylaoffx	=	*
	org 	*+3
; check if lamp is on aux board a= gh, check bits #gh off at add (020F + h) a is state , a = 00 lamp off, a = 01 lamp = on
ylachx 	=	*
	org 	*+3



; add before
	org	adralt	
	endm
	list